
/** Date of Offline Values **/
var dbrefreshOffline=1363342275390;


var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

function getFeed() {
	var sString=Property.getNode('/system/version/distroVersion').getValue();
	if (sString.indexOf('devel')>=0)
		return 0;
	if (sString.indexOf('test')>=0)
		return 1;
	if (sString.indexOf('beta')>=0)
		return 2;
	if (sString.indexOf('alpha')>=0)
		return 2;
	
	return 3;
}

function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

function refreshCache() 
{
    var db_data;
    var db_update;
    
    try {
        var h = new HTTP( { 'debug' : 0 }, {});
        lInfo.logln("http://illuminant-wizard.aizo.net/optimiertes-fetchDB.php?feed=" + getFeed());
        var code = h.get("http://illuminant-wizard.aizo.net/fetchDB.php?feed=" + getFeed(), 'optimiertes_fetchDB.php?feed=' + getFeed());
        if (code.status.valueOf() === 200) {
            //lInfo.logln('OK [' + code.status + ']' + code.body);           
            var oAnswer=JSON.parse(code.body);
            var fFound=false;
            for (var iIndex=0;iIndex<oAnswer.statics.manufacture.length;iIndex++) {
            	if (oAnswer.statics.manufacture[iIndex].id==-1)
            		fFound=true;
            }
            if (!fFound)
            	oAnswer.statics.manufacture.push({id:-1,name:'Standard',url:'www.aizo.com'});
            oAnswer.statics.mountingForm.push({id:-1,name:'-'});
            oAnswer.statics.socket.push({id:-1,name:'-'});
            oAnswer.statics.abilityDetail.push({id:"-1",name:"-"});
            var oCurves=[{abidetail:-1,dimmMin:-1,dimmType:0,dsabi:2,id:-1,illcount:1,values:[{pos:0,val:0,humm:-1,flick:-1},{pos:255,val:9999,humm:-1,flick:-1}]}];
            
            oAnswer.illuminant.push({id:-1,name:"Standard - Werkseinstellung",colortemp:"",ean:"",lumen:"",manu_id:-1,mount_id:-1,socket_id:-1,watt:"150",winkel:0,curves:oCurves});
            
            if (getFeed()<=1) {
            	oCurves=[{abidetail:-1,dimmMin:-1,dimmType:0,dsabi:2,id:-2,illcount:1,values:[{pos:0,val:0,humm:-1,flick:-1},{pos:255,val:9999,humm:-1,flick:-1}]}];
            	oAnswer.illuminant.push({id:-2,name:"0-100% ohne RK Fenster",colortemp:"",ean:"",lumen:"",manu_id:-1,mount_id:-1,socket_id:-1,watt:"150",winkel:0,curves:oCurves});
            	oCurves=[{abidetail:-1,dimmMin:-1,dimmType:0,dsabi:2,id:-3,illcount:1,values:[{pos:0,val:0,humm:-1,flick:-1},{pos:255,val:9999,humm:-1,flick:-1}]}];
            	oAnswer.illuminant.push({id:-3,name:"0-100% mit RK Fenster",colortemp:"",ean:"",lumen:"",manu_id:-1,mount_id:-1,socket_id:-1,watt:"150",winkel:0,curves:oCurves})   ;             	
            }
            
            storeSubParameter("dbcache",JSON.stringify(oAnswer));
            storeSubParameter("dbrefresh",""+(new Date()).getTime());
            Property.store();
            new Event('led-wizard.answer',{result:true,error:'',type:'saveDB'}).raise();
        } else {
            lWarn.logln(sString + ': FAILED! Server replied: "' + code.status + '"');
            lInfo.logln(code.body);
        }
    } catch (e) {
        lWarn.logln("Error during resyncing cache");
        for (var i in e) {
            lWarn.logln(i + ': ' + e[i]);
        }
    }

	var iSavedDate=-1;
	try {
		if (Property.getNode('dbrefresh')!=null)
			if (Property.getNode('dbrefresh').getValue()!=null)
				iSavedDate=Property.getNode('dbrefresh').getValue();
		if (iSavedDate<dbrefreshOffline) {
			lWarn.logln('must using offline cache');
			new Event('led-wizard.sync-offline',{}).raise();
		} else
			lWarn.logln('using online cache');
	} catch (e) {
	    lWarn.logln("Error during resyncing cache");
	    for (var i in e) {
	        lWarn.logln(i + ': ' + e[i]);
	    }
	}
}

function useOfflineCache() {
	var iSavedDate=-1;    
	try {
		lWarn.logln('now using offline cache');
        storeSubParameter("dbcache",JSON.stringify(dbcacheOffline));
        storeSubParameter("dbrefresh",""+dbrefreshOffline);
        Property.store();
	} catch (e) {
	    lWarn.logln("Error during resyncing cache");
	    for (var i in e) {
	        lWarn.logln(i + ': ' + e[i]);
	    }
	}
		
}

try {
	if (dbcacheOffline!=null)
	    lWarn.logln("----> Offline Cache loaded");
	else
	    lWarn.logln("----> NULL offline cache");
} catch (e) {
    lWarn.logln("----> NO offline cache");
}

if (raisedEvent.name== 'led-wizard.sync-offline') {
	useOfflineCache();
} else 
	if (raisedEvent.parameter.actions != null) {
		Property.load();
	    if (raisedEvent.parameter.actions == 'syncOnline') {
	        //refreshCache();
	        //Property.store();
	    }
		if (raisedEvent.parameter.actions == "load") {
	        refreshCache();
	        Property.store();
		}	
	}
	
